{***************************************************************************}
{                               UNIDAD DE PCX

                                  Copyright (c) 1998 Marco Antonio Alvarado
}
{***************************************************************************}

UNIT UPCX;

INTERFACE

  TYPE

{Registro de la Cabeza.}
    RCabeza = RECORD

{Creador (10 : ZSoft).}
      Creador : Byte;

{Versin.
  2 : viejo PCX sin Paleta.
  3 : sin Paleta.
  4 : para Microsoft Windows sin Paleta.
  5 : con Paleta.}
      Version : Byte;

{Codificacin (1).}
      Codificacion : Byte;

{Tamao del punto (1, 2, 4, 8).}
      TamanoPunto : Byte;

{Dimensiones inclusivas de la ventana.}
      XMenor : Integer;
      YMenor : Integer;
      XMayor : Integer;
      YMayor : Integer;

{Resoluciones en puntos por pulgada.}
      ResolucionX : Integer;
      ResolucionY : Integer;

{Intensidades de la paleta de 16 colores. Tambin se usa en paletas de menos
colores.}
      Paleta16 : ARRAY [0..15] OF RECORD
        Rojo,
        Verde,
        Azul : Byte;
      END;

{Modo de video.}
      Modo : Byte;

{Nmero de planos.}
      Planos : Byte;

{Nmero de letras por lnea de un plano.}
      TamanoPlano : Integer;

{Tipo de paleta.
  1 : blanco y negro, o colores.
  2 : grises.}
      TipoPaleta : Integer;

{Tamao de la pantalla.}
      AnchoPantalla : Integer;
      AltoPantalla : Integer;

{Completa 128 letras.}
      Relleno : ARRAY [74..127] OF Byte;
    END;

{Lee la Cabeza del archivo.}
  PROCEDURE LeeCabeza (Nombre : STRING; VAR Cabeza : RCabeza);

{Lee la Pintura de 256 colores y la descomprime.}
  PROCEDURE LeePintura (Nombre : STRING; Pintura : Pointer; Cantidad : Word);

{Lee la paleta de 256 colores y la ajusta.}
  PROCEDURE LeeMezcla (Nombre : STRING; Mezcla : Pointer; Cantidad : Word);

IMPLEMENTATION

  PROCEDURE LeeCabeza (Nombre : STRING; VAR Cabeza : RCabeza);

    VAR
      PCX : FILE;

  BEGIN
    Assign (PCX, Nombre);
    Reset (PCX, 1);
    BlockRead (PCX, Cabeza, SizeOf (Cabeza));
    Close (PCX);
  END;

  PROCEDURE LeePintura (Nombre : STRING; Pintura : Pointer; Cantidad : Word);

    VAR
      PCX : FILE;
      TamanoComprimido : Word;
      Comprimido : Pointer;
      Cuenta : Word;
      IndiceComprimido : Pointer;
      IndicePintura : Pointer;
      Corrida : Word;

  BEGIN
    Assign (PCX, Nombre);
    Reset (PCX, 1);
    Seek (PCX, 128);
    TamanoComprimido := FileSize (PCX) - 897;
    GetMem (Comprimido, TamanoComprimido);
    BlockRead (PCX, Comprimido^, TamanoComprimido);
    Close (PCX);
    Cuenta := 0;
    IndiceComprimido := Comprimido;
    IndicePintura := Pintura;

    WHILE Cuenta < Cantidad DO
    BEGIN

      IF (Byte (IndiceComprimido^) AND 192) = 192 THEN
      BEGIN
        Corrida := Byte (IndiceComprimido^) AND 63;
        Inc (LongInt (IndiceComprimido));
        FillChar (IndicePintura^, Corrida, Byte (IndiceComprimido^));
        Inc (LongInt (IndicePintura), Corrida);
        Inc (Cuenta, Corrida);
      END ELSE
      BEGIN
        Byte (IndicePintura^) := Byte (IndiceComprimido^);
        Inc (LongInt (IndicePintura));
        Inc (Cuenta);
      END;

      Inc (LongInt (IndiceComprimido));
    END;

    FreeMem (Comprimido, TamanoComprimido);
  END;

  PROCEDURE LeeMezcla (Nombre : STRING; Mezcla : Pointer; Cantidad : Word);

    VAR
      PCX : FILE;
      Indice : Pointer;
      Intensidad : Word;

  BEGIN
    Assign (PCX, Nombre);
    Reset (PCX, 1);
    Seek (PCX, FileSize (PCX) - 768);
    BlockRead (PCX, Mezcla^, Cantidad);
    Close (PCX);
    Indice := Mezcla;

    FOR Intensidad := 1 TO Cantidad DO
    BEGIN
      Byte (Indice^) := Byte (Indice^) SHR 2;
      Inc (LongInt (Indice));
    END;

  END;

END.